function [ G, DistGraph ] = build_KNN_DIST_ADJ_subset( A, k, targetNodes, distance_type )

% targetNodes = 1:n  to  compute the neighborhood for each node

% G is symmetric

% 'Distance'     A string or a function handle specifying the distance
%     metric. The value can be one of the following:
%           'euclidean'   - Euclidean distance (default).

% distance_type = 'euclidean';
  
k = k+1;  %  it also adds itself as a neighbor

n = size(A,1);
[ IDX, DIST ] = knnsearch(A, A, 'Distance', distance_type, 'K', k);

Q = zeros( length(targetNodes)  * (k-1) ,2);

ctr = 0;
for i = targetNodes
    % disp(i);
    nbrs = IDX(i,2:k)';
    dists = DIST(i,2:k)';
    
    r = repmat(i,k-1,1);
    Q( (ctr+1):(ctr+k-1) , 1:2 ) = [r nbrs];
    Q( (ctr+1):(ctr+k-1) , 3 ) = dists;
    ctr = ctr + k-1;
end

nr_entries = ctr;

G = sparse(Q(:,1),Q(:,2),ones(nr_entries,1), n, n);

DistGraph = sparse(Q(:,1), Q(:,2), Q(:,3), n, n);
DistGraph = DistGraph + DistGraph';

GwTwos = G + G';
pozTwos = GwTwos == 2;

G = GwTwos;
G(pozTwos) = 1;
DistGraph(pozTwos) = DistGraph(pozTwos) / 2;

end

