function [ f_est_OLS, f_mod1_est_OLS, err_f_OLS, err_f_mod1_OLS,    f_est_noShift_OLS ,  runningTime_OLS] = ...
    ols_solver( f_clean, f_mod1_clean, f_noise, f_mod1_noise,...
    k, sigma, x_grid, DATA ,PARS, to_plot )

% nx1 vector: f_orig (clean samples of f)
% nx1 vector: f_mod1_clean (clean mod 1 samples of f)
% nx1 vector: f_noise (noisy sampled of f)
% nx1 vector: f_mod_1_noise (noisy mod 1 samples of f)
%--------------------------------------------------------------------------

n = length(f_mod1_noise);
y = f_mod1_noise;
epsilon = 0.5;
b = zeros(10*n,1);
ind_i = zeros(10*n,3);
ind_j = zeros(10*n,3);

ctr_edges = 0;
for i = 1:(n-1)
    for j = (i+1): min((i+k), n)
        ctr_edges = ctr_edges + 1;
        if (y(i) - y(j) > epsilon)
            q_j_minus_q_i = 1;
        elseif (y(i) - y(j) < - epsilon)
            q_j_minus_q_i = -1;
        else
            q_j_minus_q_i = 0;
        end
        
        b(ctr_edges) = y(i) - y(j) - q_j_minus_q_i;
        % A(ctr_edges,i) =  1;
        % A(ctr_edges,j) = -1;
        
        ind_i(ctr_edges, :) = [ctr_edges i  1];
        ind_j(ctr_edges, :) = [ctr_edges j -1];
    end
end


ind_i = ind_i(1:ctr_edges,:);
ind_j = ind_j(1:ctr_edges,:);
ALL_IND = [ ind_i
            ind_j ];

A_fast = sparse( ALL_IND(:,1),  ALL_IND(:,2),  ALL_IND(:,3), ctr_edges, n );

A = A_fast;
b = b(1:ctr_edges);

tic
f_est_OLS = A\b;
runningTime_OLS = toc;
f_est_OLS = f_est_OLS';
f_est_noShift_OLS = f_est_OLS;
[ f_est_OLS ] = optimalShift(f_est_OLS, f_clean);

f_mod1_est_OLS = mod(f_est_OLS, 1);

err = getErrors(f_clean, f_est_OLS);
err_f_OLS = err(1);

err = getErrors(f_mod1_clean, f_mod1_est_OLS);
err_f_mod1_OLS = err(1);

end


